You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

217 lines
8.1KB

  1. #!/usr/bin/env bash
  2. set -o noclobber -o noglob -o nounset -o pipefail
  3. IFS=$'\n'
  4. # If the option `use_preview_script` is set to `true`,
  5. # then this script will be called and its output will be displayed in ranger.
  6. # ANSI color codes are supported.
  7. # STDIN is disabled, so interactive scripts won't work properly
  8. # This script is considered a configuration file and must be updated manually.
  9. # It will be left untouched if you upgrade ranger.
  10. # Meanings of exit codes:
  11. # code | meaning | action of ranger
  12. # -----+------------+-------------------------------------------
  13. # 0 | success | Display stdout as preview
  14. # 1 | no preview | Display no preview at all
  15. # 2 | plain text | Display the plain content of the file
  16. # 3 | fix width | Don't reload when width changes
  17. # 4 | fix height | Don't reload when height changes
  18. # 5 | fix both | Don't ever reload
  19. # 6 | image | Display the image `$IMAGE_CACHE_PATH` points to as an image preview
  20. # 7 | image | Display the file directly as an image
  21. # Script arguments
  22. FILE_PATH="${1}" # Full path of the highlighted file
  23. PV_WIDTH="${2}" # Width of the preview pane (number of fitting characters)
  24. PV_HEIGHT="${3}" # Height of the preview pane (number of fitting characters)
  25. IMAGE_CACHE_PATH="${4}" # Full path that should be used to cache image preview
  26. PV_IMAGE_ENABLED="${5}" # 'True' if image previews are enabled, 'False' otherwise.
  27. FILE_EXTENSION="${FILE_PATH##*.}"
  28. FILE_EXTENSION_LOWER=$(echo ${FILE_EXTENSION} | tr '[:upper:]' '[:lower:]')
  29. # Settings
  30. HIGHLIGHT_SIZE_MAX=262143 # 256KiB
  31. HIGHLIGHT_TABWIDTH=8
  32. HIGHLIGHT_STYLE='pablo'
  33. PYGMENTIZE_STYLE='autumn'
  34. handle_extension() {
  35. case "${FILE_EXTENSION_LOWER}" in
  36. # Archive
  37. a|ace|alz|arc|arj|bz|bz2|cab|cpio|deb|gz|jar|lha|lz|lzh|lzma|lzo|\
  38. rpm|rz|t7z|tar|tbz|tbz2|tgz|tlz|txz|tZ|tzo|war|xpi|xz|Z|zip)
  39. atool --list -- "${FILE_PATH}" && exit 5
  40. bsdtar --list --file "${FILE_PATH}" && exit 5
  41. exit 1;;
  42. rar)
  43. # Avoid password prompt by providing empty password
  44. unrar lt -p- -- "${FILE_PATH}" && exit 5
  45. exit 1;;
  46. 7z)
  47. # Avoid password prompt by providing empty password
  48. 7z l -p -- "${FILE_PATH}" && exit 5
  49. exit 1;;
  50. # PDF
  51. pdf)
  52. # Preview as text conversion
  53. pdftotext -l 10 -nopgbrk -q -- "${FILE_PATH}" - | fmt -w ${PV_WIDTH} && exit 5
  54. mutool draw -F txt -i -- "${FILE_PATH}" 1-10 | fmt -w ${PV_WIDTH} && exit 5
  55. exiftool "${FILE_PATH}" && exit 5
  56. exit 1;;
  57. # BitTorrent
  58. torrent)
  59. transmission-show -- "${FILE_PATH}" && exit 5
  60. exit 1;;
  61. # OpenDocument
  62. odt|ods|odp|sxw)
  63. # Preview as text conversion
  64. odt2txt "${FILE_PATH}" && exit 5
  65. exit 1;;
  66. # HTML
  67. htm|html|xhtml)
  68. # Preview as text conversion
  69. w3m -dump "${FILE_PATH}" && exit 5
  70. lynx -dump -- "${FILE_PATH}" && exit 5
  71. elinks -dump "${FILE_PATH}" && exit 5
  72. ;; # Continue with next handler on failure
  73. esac
  74. }
  75. handle_image() {
  76. local mimetype="${1}"
  77. case "${mimetype}" in
  78. # SVG
  79. # image/svg+xml)
  80. # convert "${FILE_PATH}" "${IMAGE_CACHE_PATH}" && exit 6
  81. # exit 1;;
  82. # Image
  83. image/*)
  84. local orientation
  85. orientation="$( identify -format '%[EXIF:Orientation]\n' -- "${FILE_PATH}" )"
  86. # If orientation data is present and the image actually
  87. # needs rotating ("1" means no rotation)...
  88. if [[ -n "$orientation" && "$orientation" != 1 ]]; then
  89. # ...auto-rotate the image according to the EXIF data.
  90. convert -- "${FILE_PATH}" -auto-orient "${IMAGE_CACHE_PATH}" && exit 6
  91. fi
  92. # `w3mimgdisplay` will be called for all images (unless overriden as above),
  93. # but might fail for unsupported types.
  94. exit 7;;
  95. # Video
  96. # video/*)
  97. # # Thumbnail
  98. # ffmpegthumbnailer -i "${FILE_PATH}" -o "${IMAGE_CACHE_PATH}" -s 0 && exit 6
  99. # exit 1;;
  100. # PDF
  101. # application/pdf)
  102. # pdftoppm -f 1 -l 1 \
  103. # -scale-to-x 1920 \
  104. # -scale-to-y -1 \
  105. # -singlefile \
  106. # -jpeg -tiffcompression jpeg \
  107. # -- "${FILE_PATH}" "${IMAGE_CACHE_PATH%.*}" \
  108. # && exit 6 || exit 1;;
  109. # Preview archives using the first image inside.
  110. # (Very useful for comic book collections for example.)
  111. # application/zip|application/x-rar|application/x-7z-compressed|\
  112. # application/x-xz|application/x-bzip2|application/x-gzip|application/x-tar)
  113. # local fn=""; local fe=""
  114. # local zip=""; local rar=""; local tar=""; local bsd=""
  115. # case "${mimetype}" in
  116. # application/zip) zip=1 ;;
  117. # application/x-rar) rar=1 ;;
  118. # application/x-7z-compressed) ;;
  119. # *) tar=1 ;;
  120. # esac
  121. # { [ "$tar" ] && fn=$(tar --list --file "${FILE_PATH}"); } || \
  122. # { fn=$(bsdtar --list --file "${FILE_PATH}") && bsd=1 && tar=""; } || \
  123. # { [ "$rar" ] && fn=$(unrar lb -p- -- "${FILE_PATH}"); } || \
  124. # { [ "$zip" ] && fn=$(zipinfo -1 -- "${FILE_PATH}"); } || return
  125. #
  126. # fn=$(echo "$fn" | python -c "import sys; import mimetypes as m; \
  127. # [ print(l, end='') for l in sys.stdin if \
  128. # (m.guess_type(l[:-1])[0] or '').startswith('image/') ]" |\
  129. # sort -V | head -n 1)
  130. # [ "$fn" = "" ] && return
  131. # [ "$bsd" ] && fn=$(printf '%b' "$fn")
  132. #
  133. # [ "$tar" ] && tar --extract --to-stdout \
  134. # --file "${FILE_PATH}" -- "$fn" > "${IMAGE_CACHE_PATH}" && exit 6
  135. # fe=$(echo -n "$fn" | sed 's/[][*?\]/\\\0/g')
  136. # [ "$bsd" ] && bsdtar --extract --to-stdout \
  137. # --file "${FILE_PATH}" -- "$fe" > "${IMAGE_CACHE_PATH}" && exit 6
  138. # [ "$bsd" ] || [ "$tar" ] && rm -- "${IMAGE_CACHE_PATH}"
  139. # [ "$rar" ] && unrar p -p- -inul -- "${FILE_PATH}" "$fn" > \
  140. # "${IMAGE_CACHE_PATH}" && exit 6
  141. # [ "$zip" ] && unzip -pP "" -- "${FILE_PATH}" "$fe" > \
  142. # "${IMAGE_CACHE_PATH}" && exit 6
  143. # [ "$rar" ] || [ "$zip" ] && rm -- "${IMAGE_CACHE_PATH}"
  144. # ;;
  145. esac
  146. }
  147. handle_mime() {
  148. local mimetype="${1}"
  149. case "${mimetype}" in
  150. # Text
  151. text/* | */xml | message/*)
  152. # Syntax highlight
  153. if [[ "$( stat --printf='%s' -- "${FILE_PATH}" )" -gt "${HIGHLIGHT_SIZE_MAX}" ]]; then
  154. exit 2
  155. fi
  156. if [[ "$( tput colors )" -ge 256 ]]; then
  157. local pygmentize_format='terminal256'
  158. local highlight_format='xterm256'
  159. else
  160. local pygmentize_format='terminal'
  161. local highlight_format='ansi'
  162. fi
  163. highlight --replace-tabs="${HIGHLIGHT_TABWIDTH}" --out-format="${highlight_format}" \
  164. --style="${HIGHLIGHT_STYLE}" --force -- "${FILE_PATH}" && exit 5
  165. # pygmentize -f "${pygmentize_format}" -O "style=${PYGMENTIZE_STYLE}" -- "${FILE_PATH}" && exit 5
  166. exit 2;;
  167. # Image
  168. image/*)
  169. # Preview as text conversion
  170. # img2txt --gamma=0.6 --width="${PV_WIDTH}" -- "${FILE_PATH}" && exit 4
  171. exiftool "${FILE_PATH}" && exit 5
  172. exit 1;;
  173. # Video and audio
  174. video/* | audio/*)
  175. mediainfo "${FILE_PATH}" && exit 5
  176. exiftool "${FILE_PATH}" && exit 5
  177. exit 1;;
  178. esac
  179. }
  180. handle_fallback() {
  181. echo '----- File Type Classification -----' && file --dereference --brief -- "${FILE_PATH}" && exit 5
  182. exit 1
  183. }
  184. MIMETYPE="$( file --dereference --brief --mime-type -- "${FILE_PATH}" )"
  185. if [[ "${PV_IMAGE_ENABLED}" == 'True' ]]; then
  186. handle_image "${MIMETYPE}"
  187. fi
  188. handle_extension
  189. handle_mime "${MIMETYPE}"
  190. handle_fallback
  191. exit 1